/* coda.c: struttura di dati "coda" realizzata mediante liste (R. Grossi, 2013) */

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "coda.h"


/* CREATE */

coda *Create( ){
  coda *p;
  
  p = (coda *) malloc( sizeof(coda) );
  p->dimensione = 0;
  p->testa = p->fondo = NULL;
  
  return p;
}

/* DESTROY */

void RecDel( nodo * u){
  if (u != NULL){
    RecDel( u->succ );
    free( u );
  }
}

coda *Destroy( coda * c ){
  assert( c != NULL );
  RecDel( c->testa );
  free( c );
  return NULL;
}

/* ENQUEUE */

void Enqueue( coda * c, elemento e ){
  assert( c != NULL );
  if ( c->dimensione == 0 ){
    c->testa = c->fondo = (nodo *) malloc( sizeof(nodo) );
  } else {
    c->fondo->succ = (nodo *) malloc( sizeof(nodo) );
    c->fondo = c->fondo->succ;
  }
  c->fondo->dato = e;
  c->fondo->succ = NULL;
  c->dimensione++;
}

/* DEQUEUE */

elemento Dequeue( coda *c ){
  elemento e;
  nodo *u;

  assert( c != NULL );
  assert( c->dimensione != 0 );
  e = c->testa->dato;
  u = c->testa;
  c->testa = c->testa->succ;
  c->dimensione--;
  free( u );

  return e;
}

/* FIRST */

elemento First( coda *c ){
  assert( c != NULL );
  assert( c->dimensione != 0 );

  return c->testa->dato;
}


/* EMPTY */

bool Empty( coda * c){
  assert( c != NULL );
  return (bool) (c->dimensione == 0 );
}

/* PRINT */

void RecPrint( nodo * u){
  if (u != NULL){
    printf( ELEMENTO_PRINTF, u->dato );
    RecPrint( u->succ );
  }
}

void Print( coda *c ){
  assert( c != NULL );
  RecPrint( c->testa );
  printf( "\n" );
}
